<?php

Class SGallery extends Page {

    static $singular_name = 'SGallery';
    static $plural_name = 'SGalleries';
    static $icon = '';
    static $db = array(
        'GalleryDesc' => "Text",
        'AlbumFolderID' => 'Int'
    );
    static $has_one = array(
        'Folder' => 'Folder',
        'CoverImage' => 'Image'
    );
    public static $has_many = array(
        'Images' => 'SGalleryimage'
    );

    //*
    function getCMSFields() {
        $fields = parent::getCMSFields();
        /*
         *  Add extra basic fields to the CMS + Extra Tab 
         *  $newFieldsArray = list of fields need to be added to tab
         *  $newFieldsArray MUST be used to add array of fields as fields need to be declared before they can be added to a tab !
         */
        $newFieldsArray = array(
            new UploadField("CoverImage"),
            new TextareaField("GalleryDesc")
        );


        /*
         * Add Gallery Section to the page using has_many relation + GridFeild 
         */
        $gridFieldConfig = GridFieldConfig_RelationEditor::create();
        $gridFieldConfig->addComponents(
                new GridFieldSortableRows("SortID")
        );


        $gridField = new GridField("SGalleryimages", "SGallery images", $this->Images(), $gridFieldConfig);
        /* Adds Thumbnail to the CMS . This is a fix so special characters are not escaped resulting in a string output */
        $gridField->getConfig()->getComponentByType('GridFieldDataColumns')->setFieldFormatting(array(
            'Thumbnail' => function($val, $obj) {
                if ($obj instanceof SGalleryImage) {
                    return $obj->getThumbnail();
                } else {
                    return $obj;
//                    return var_dump($obj);
                }
            },
        ));
        /* Customize the List Display in the CMS */
        $gridField->getConfig()->getComponentByType('GridFieldDataColumns')->setDisplayFields(array(
            'SortID' => 'SortID',
            'Thumbnail' => 'Thumbnail',
            'Title' => 'Title',
            'ID' => 'ID'
        ));

        /* Auto list folders in SGallery/plugins/ */
        /*
          $album = Folder::get()->filter('Filename', 'assets/plugins/')->first();;
          //        var_dump($album);
          //        Debug::dump($album);die;

          if ($album) {
          $tree = new TreeDropdownField(
          'AlbumFolderID',
          _t(
          'SGallery.CHOOSEALBUMFOLDER', 'Choose album folder (subfolder assets/plugins/)'
          ),
          'Folder'
          );
          $tree->setTreeBaseID((int) $album->ID);
          $fields->addFieldToTab("Root.Main", $tree, 'Content');
          }
         * 
         */


        /* Add firlds to tabs */
        $fields->addFieldsToTab("Root.Settings", $newFieldsArray, "");
        $fields->addFieldToTab("Root.GalleryImages", $gridField);

        return $fields;
    }

    /*
     * Attempt to create custom folder for each SGallerypage 
      function findOrMakeFolder() {
      $Title = SiteTree::generateURLSegment($this->Title);
      if ($this->Folder() && $this->Folder()->exists()) {
      $folder = $this->Folder();
      } else {
      $folder = Folder::findOrMake($Title);
      $folder->write();
      }
      $folder->Name =$Title;
      $folder->Title = $Title;
      $this->FolderID = $folder->ID;
      $folder->write();
      }
     * 
     */

    function onBeforeWrite() {
        parent::onBeforeWrite();
        //$this->findOrMakeFolder();
    }

    function onBeforeDelete() {
        parent::onBeforeDelete();
    }

}

class SGallery_Controller extends Page_Controller {

    function init() {
        parent::init();
    }

    function RenderGallery($templatename="Default") {
        $renderWithArray = array(
            
            "SGallery-".$templatename

        );
        if (isset($templatename)) {
            return $this->renderWith($renderWithArray);
        }
    }


}